unit main_testdrop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RVScroll, RichView, RVEdit, ExtCtrls, ComCtrls, RVStyle
  ,CRVdata
  ,inifiles
  ,transparency_drop
  ;

type
  TForm8 = class(TForm)
    RVStyle1: TRVStyle;
    tv: TTreeView;
    Splitter1: TSplitter;
    Panel1: TPanel;
    RVE_weekly_drop: TRichViewEdit;
    RVE_general_drop: TRichViewEdit;
    Splitter2: TSplitter;

    procedure WndProc(var TheMsg: TMessage); override;
    procedure WMSyscommand(var msg: TWmSysCommand); message WM_SYSCOMMAND;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RVE_general_dropReadHyperlink(Sender: TCustomRichView;
      const Target, Extras: String; DocFormat: TRVLoadFormat; var StyleNo,
      ItemTag: Integer; var ItemName: String);
    procedure RVE_general_dropWriteHyperlink(Sender: TCustomRichView;
      id: Integer; RVData: TCustomRVData; ItemNo: Integer;
      SaveFormat: TRVSaveFormat; var Target, Extras: String);
  private
    { Private declarations }
    firsttime :boolean;
  public
    { Public declarations }
  end;

var
  Form8: TForm8;

implementation
{$R *.dfm}


procedure TForm8.WMSyscommand(var msg: TWmSysCommand);
(*******************************************************************************
If this form is minimized, we popup the floating/transpararent drop icon.
To prevnet multiple instances of this program in the taskbar,
we remove this form from the taskbar.
*******************************************************************************)
var
  hwndOwner  :HWnd;
  inifile    :tinifile;
  ini_header :string;
begin
  case (msg.CmdType and $FFF0) of
    SC_MINIMIZE:
      begin
        if Form_transparent_drop=nil then application.CreateForm(tForm_transparent_drop,Form_transparent_drop);
        Form_transparent_drop.drop_target2:=RVE_general_drop;
        Form_transparent_drop.drop_target3:=RVE_weekly_drop;

        //all important options should be set in code (instead of object inspector
        Form_transparent_drop.RVE_drop.RVFOptions:=RVE_general_drop.RVFOptions;
        Form_transparent_drop.RVE_drop.Style:=RVStyle1;
        Form_transparent_drop.RVE_drop.Options:=RVE_general_drop.Options;
        Form_transparent_drop.RVE_drop.AcceptDragDropFormats:=RVE_general_drop.AcceptDragDropFormats;
        Form_transparent_drop.RVE_drop.RVFTextStylesReadMode:=rvf_sIgnore;
        Form_transparent_drop.RVE_drop.RVFParaStylesReadMode:=rvf_sIgnore;
        Form_transparent_drop.RVE_drop.RTFReadProperties.TextStyleMode:=rvrsUseClosest;
        Form_transparent_drop.RVE_drop.RTFReadProperties.ParaStyleMode:=rvrsUseClosest;
        Form_transparent_drop.RVE_drop.OnReadHyperlink:=RVE_general_dropReadHyperlink;

        Form_transparent_drop.show;
        hide;

        //here hide this form from the taskbar
        //(transparency form should set this back !!)
        hwndOwner := GetWindow(Handle, GW_OWNER);
        ShowWindow(hwndOwner, SW_HIDE);
        // For Windows 2000, additionally call the ShowWindowAsync function:
        ShowWindowAsync(hwndOwner, SW_HIDE);
      end;
    else
    begin
      inherited;
    end;
  end;
end;


procedure TForm8.WndProc(Var TheMsg: TMessage);
(*******************************************************************************
Afhandeling messages afkomstig van USB-programmer
  wparamlo = command
  wparamhi = extra parameter
  lparam   = handle of the calling form
*******************************************************************************)
var
  drop_location :integer;
  i             :integer;
begin
  if (TheMsg.Msg = WM_MDI_menu_message) then
  begin
    drop_location:=TheMsg.wparam;
    case drop_location of
      1:with Form_transparent_drop.RVE_drop do
        begin
          for i:=0 to itemcount-1 do
            if getitemtextA(i)<>'' then
              tv.Items.AddChildFirst(tv.Items[0],getitemtextA(i));
        end;
      //the next two condtions are not necessary,
      //contents is directly dropped on the drop_target2/3
      2:with Form_transparent_drop.RVE_drop do
        begin
          RVE_general_drop.AppendFrom(form_transparent_drop.RVE_drop);
          RVE_general_drop.Reformat;
        end;
      3:with Form_transparent_drop.RVE_drop do
        begin
          RVE_weekly_drop.AppendFrom(form_transparent_drop.RVE_drop);
//          for i:=0 to itemcount-1 do
//            RVE_weekly_drop.AddNL(getitemtextA(i),GetItemStyle(i),GetItemPara(i));
          RVE_weekly_drop.Reformat;
        end;
    end;
    with Form_transparent_drop.RVE_drop do
    begin
      clear;
      reformat;
    end;
  end
  else inherited WndProc(TheMsg);
end;


procedure TForm8.FormCreate(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
begin
  firsttime:=true;
end;


procedure TForm8.FormActivate(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
var
  ii :integer;
  inifile :tinifile;
begin
  if firsttime then
  begin
    firsttime:=false;
    RVE_general_drop.LoadRVF(extractfilepath(application.ExeName)+'demo_drop.rvf');
    RVE_general_drop.format;

    //all important options should be set in code (instead of object inspector
    RVE_general_drop.RVFOptions:=[ rvfoSavePicturesBody,
                      rvfoSaveControlsBody,
                      rvfoConvUnknownStylesToZero,
                      rvfoSaveBinary,
                      rvfoSaveDocProperties,
                      rvfoLoadDocProperties];
    RVE_weekly_drop.RVFOptions:=RVE_general_drop.RVFOptions;


    // This demo program is saved in Delphi 2, where Charset property is not available.
    // So assigning non-default charset here:
    {$IFDEF RICHVIEWCBDEF3} // For Delphi3+, C++Builder 3+
    RVStyle1.TextStyles[6].Charset := SYMBOL_CHARSET;
    RVStyle1.ListStyles[0].Levels[0].Font.Charset := SYMBOL_CHARSET;
    {$ENDIF}

    // Item can have associated "tags" - integers or strings.
    // Comment next line to use integer tags
    RVE_general_drop.Options := RVE_general_drop.Options+[rvoTagsArePChars];
    RVE_weekly_drop.Options:=RVE_general_drop.Options;
    RVE_general_drop.AcceptDragDropFormats:=
      RVE_general_drop.AcceptDragDropFormats+[rvddURL];
    RVE_weekly_drop.AcceptDragDropFormats:=RVE_general_drop.AcceptDragDropFormats;

    //ignore document styles !!
    RVE_general_drop.RVFTextStylesReadMode:=rvf_sIgnore;
    RVE_general_drop.RVFParaStylesReadMode:=rvf_sIgnore;
    RVE_weekly_drop.RVFTextStylesReadMode:=rvf_sIgnore;
    RVE_weekly_drop.RVFParaStylesReadMode:=rvf_sIgnore;

    //Importing of RTF may not create new styles
    RVE_general_drop.RTFReadProperties.TextStyleMode:=rvrsUseClosest;
    RVE_general_drop.RTFReadProperties.ParaStyleMode:=rvrsUseClosest;
    RVE_weekly_drop.RTFReadProperties.TextStyleMode:=rvrsUseClosest;
    RVE_weekly_drop.RTFReadProperties.ParaStyleMode:=rvrsUseClosest;


    inifile:=tinifile.create(extractfilepath(application.exename)+'test_browser.ini');
    with inifile do
    try
      if sectionexists('RVStyle1') then
      begin
        RVStyle1.LoadFromINI(inifile,'RVStyle1');
        //make the numbered liststyle font like the normal textstyle font, but BOLD
        //special settings for the liststyles
        // use symbols-characterset for the bullits
        // use bold-normal font for the numbered lists
        RVStyle1.ListStyles[0].Levels[0].Font.Charset := SYMBOL_CHARSET;
        for ii:=0 to RVStyle1.ListStyles[1].Levels.count-1 do
        begin
          RVStyle1.ListStyles[1].Levels[ii].Font.assign(RVStyle1.TextStyles[0]);
        end;
  

      end;
    finally
      inifile.free
    end;
    RVStyle1.DefUnicodeStyle:=-1;
    RVStyle1.TextStyles[11].Unicode:=false;

    //we also store the background color in the style tag
    RVStyle1.Tag:=RVStyle1.Color;
    //in openfile, this is set to zero for RTF-files
    RVStyle1.SpacesInTab:=8;

  end;
end;


function is_URL(line:string):boolean;
(*******************************************************************************
*******************************************************************************)
begin
  result:=false;
  line:=lowercase(line);
  if (pos('http://',line)=1) or
     (pos('https://',line)=1) or
     (pos('ftp://',line)=1) {or
     (pos('file:///',line)=1)} then result:=true;
end;


function get_rel_link(line:string):string;
(*******************************************************************************
Translates a link
  - try to translate relative to this file
  - add "file:///" if it start with a diskname
*******************************************************************************)
var
  path :string;
begin
  if is_URL(line) then result:=line
  else
  begin
    path:=extractfilepath(application.ExeName);
    if pos('file:',line)=1 then line:=copy(line,9,length(line)-8);
    line:=StringReplace(line, '/', '\', [rfReplaceall]);
    result:=extractrelativepath(path,line);
    //if link specifies a drive, add "file"
    if (length(result)>1) and (result[2]=':') then
      result:='file:///'+result;
  end;
  result := StringReplace(result, '\', '/', [rfReplaceall]);
end;


procedure TForm8.RVE_general_dropReadHyperlink(Sender: TCustomRichView;
  const Target, Extras: String; DocFormat: TRVLoadFormat; var StyleNo,
  ItemTag: Integer; var ItemName: String);
(*******************************************************************************
Occures when a hyperlink is dropped,
here the name is changed to the title of the page
and a newline should be inserted afterwards
--
if dropped on newline (the 2 spaces belong to the link)
postmessage doesn't improve that
******************************************************************************)
var
  ii   :integer;
  line :string;
var URL: String;
begin
  //apparently DocFormat can be used to distingish between dropURL and READURL-RTF
  if not(DocFormat=rvlfURL) then
  begin
    StyleNo:=4;
    //URL := rvActionsResource.rvActionInsertHyperlink1.EncodeTarget(Target);
    url:=get_rel_link(target);
    ItemTag := Integer(StrNew(PChar(URL)));
  end
  else
  begin
    TRichViewEdit(sender).InsertText(#13+'  ');

    line:=get_rel_link(target);
    TRichViewEdit(sender).CurTextStyleNo:=4;
    TRichViewEdit(sender).InsertStringTag(itemname,integer(strnew(pchar(line))));
    TRichViewEdit(sender).InsertText(#13);
    itemname:='';

    ii:=TRichViewEdit(sender).curitemno;
//    postmessage(handle,WM_SET_CARET,ii,ii);
  end;
end;

procedure TForm8.RVE_general_dropWriteHyperlink(Sender: TCustomRichView;
  id: Integer; RVData: TCustomRVData; ItemNo: Integer;
  SaveFormat: TRVSaveFormat; var Target, Extras: String);
(*******************************************************************************
replaces onURLneeded
******************************************************************************)
begin
  Target := PChar(RVData.GetItemTag(ItemNo));
end;

end.
