unit transparency_drop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls,
  Menus,
  inifiles,
  transparency_setting, RVStyle, DropSource, DropTarget, DropALLtarget,
  GIFImage, ExtCtrls, TGIFimageEX
//  ,datamodule_PuntHoofd
  ,RVScroll, RichView, RVEdit
  ,activex
  ,MultiDropTarget
  ;

const
//  inifile_name='D:\Data_actueel\D7_test_browser\test_browser.ini';
  WM_MDI_menu_message =wm_user+23;
type
  TForm_transparent_drop = class(TForm)
    PopupMenu1: TPopupMenu;
    Transparency1: TMenuItem;
    PuntHoofd1: TMenuItem;
    help1: TMenuItem;
    Label1: TLabel;
    RVStyle1: TRVStyle;
    Image_close: TImageEx;
    RVE_drop: TRichViewEdit;
    Image1: TImage;
    Image3: TImage;
    Image2: TImage;
    Image0: TImage;

    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

    procedure RVE_dropRVMouseDown(Sender: TCustomRichView;
      Button: TMouseButton; Shift: TShiftState; ItemNo, X, Y: Integer);
    procedure RVE_dropMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure RVE_dropDropFiles(Sender: TCustomRichViewEdit;
      Files: TStrings; var FileAction: TRVDropFileAction;
      var DoDefault: Boolean);


    procedure PopupMenu1Popup(Sender: TObject);
    procedure Transparency1Click(Sender: TObject);
    procedure PuntHoofd1Click(Sender: TObject);
    procedure help1Click(Sender: TObject);

  private
    { Private declarations }
    book_old         :integer;
    drop_location    :integer;

    firsttime        :boolean;

    mouse_down_x     :integer;
    mouse_down_y     :integer;

    RVT              :TRichViewTarget;

    transparency_org :integer;

    procedure set_book(book:integer);
    procedure select_book_position(x:integer);
    procedure set_transparency(transparant:integer);

    procedure OleEnter(Sender: TObject);
    procedure OleDragOver(Sender: TCustomRichView; X, Y: Integer;
      var CanDropHere: Boolean);
    procedure OleBeforeDrop(Sender: TCustomRichView; X, Y: Integer;
      var CanDropHere: Boolean);
    procedure OleAfterDrop(Sender: TCustomRichView; X, Y: Integer;
      Format: TRVDragDropFormat; const Title: String);
    procedure OleDropNotAccepted(Sender: TObject);
    procedure OleLeave(Sender: TObject);

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMSetTransparency(var Msg:TMessage); message WM_Set_Transparency;
  public
    { Public declarations }
    drop_target2      :TCustomRichView;
    drop_target3      :TCustomRichView;
  end;


var
  Form_transparent_drop: TForm_transparent_drop;
  inifile_name :string;

implementation
{$R *.dfm}


const
  transparency_max =205;


(*******************************************************************************
Create a captionless form and
Ensure that the form really stays on top
(by making Desktop the parent)
*******************************************************************************)
procedure TForm_transparent_drop.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do begin
    ExStyle := ExStyle or WS_EX_TOPMOST;
    WndParent := GetDesktopwindow;
  end;
end;


procedure TForm_transparent_drop.WMSetTransparency(var Msg:TMessage);
(*******************************************************************************
Needed for transparency setting through the transparency settings form
*******************************************************************************)
begin
  transparency_org:=Msg.Wparam;
  set_transparency(transparency_org);
end;


procedure TForm_transparent_drop.set_transparency(transparant:integer);
(*******************************************************************************
transparency 0...255
*******************************************************************************)
begin
  if transparant<50 then transparant:=50
  else if transparant>transparency_max then transparant:=transparency_max;
  alphablendvalue:=transparant;
  alphablend:=true;
end;


procedure TForm_transparent_drop.set_book(book:integer);
(*******************************************************************************
Highlight left or right part of the book, during mouseover,
by loading the correct image
*******************************************************************************)
begin
  if book<>book_old then
    case book of
      0: RVT.BackgroundBitmap:=Image0.Picture.Bitmap;
      1: RVT.BackgroundBitmap:=Image1.Picture.Bitmap;
      2: RVT.BackgroundBitmap:=Image2.Picture.Bitmap;
      3: RVT.BackgroundBitmap:=Image3.Picture.Bitmap;
    end;
  book_old:=book;
end;


procedure TForm_transparent_drop.select_book_position(x:integer);
(*******************************************************************************
Calculate the drop (or mouse) position
*******************************************************************************)
var
  w    :integer;
begin
  set_transparency(transparency_max);
  w:=Image1.Picture.Bitmap.Width div 2;
  if x<(w-4) then drop_location:=1
  else if x<(w+4) then drop_location:=2
  else drop_location:=3;
  set_book(drop_location);
end;


procedure TForm_transparent_drop.FormCreate(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
var
  w :integer;
begin
  label1.Caption:=changefileext(extractfilename(inifile_name),'');
  w:=Image1.Picture.Bitmap.Width;
  Width:=w+2*label1.Height;
  height:=width;

  rvt := TRichViewTarget.Create(Self);
  rvt.Parent := Self;
  rvt.Style := RVStyle1;
  rvt.BackgroundStyle := bsStretched; //bsCentered;
  rvt.BackgroundBitmap := Image0.Picture.Bitmap;
  rvt.BorderStyle := bsNone;
  rvt.Width := Image0.Picture.Bitmap.Width;
  rvt.Height := Image0.Picture.Bitmap.Height;
  rvt.OnOleDragEnter := OleEnter;
  rvt.OnOleDragLeave := OleLeave;
  rvt.OnOleBeforeDrop := OleBeforeDrop;
  rvt.OnOleAfterDrop := OleAfterDrop;
  rvt.OnOleDropNotAccepted := OleDropNotAccepted;
  RVT.OnOleDragOver:=OleDragOver;//RVE_dropOleDragOver;



  RVT.OnRVMouseDown:=RVE_dropRVMouseDown;    //to enable dragging the form
  RVT.OnMouseMove:=RVE_dropMouseMove;
  //  RVT.OnDblClick:=  PuntHoofd1Click;         //doesn't work very well

  clientwidth:=Image0.Picture.Bitmap.Width+2*label1.Height;
  clientheight:=clientwidth;
  RVT.Width:=w;
  RVT.Height:=RVT.Width;
  RVT.top:=label1.Height;
  RVT.Left:=RVT.Top;

  firsttime:=true;
end;


procedure TForm_transparent_drop.OleDropNotAccepted(Sender: TObject);
(*******************************************************************************
// Called after OleBeforeDrop instead of OleAfterDrop if the dropped data
// are not accepted
*******************************************************************************)
begin
{  AlphaBlendValue := 150;
  frmView.Free;
  frmView := nil;}
end;


procedure TForm_transparent_drop.OleDragOver(Sender: TCustomRichView; X, Y: Integer;
  var CanDropHere: Boolean);
(*******************************************************************************
*******************************************************************************)
begin
  select_book_position(x);
  CanDropHere:=True;
end;


procedure TForm_transparent_drop.OleBeforeDrop(
  Sender: TCustomRichView; X, Y: Integer;
  var CanDropHere: Boolean);
(*******************************************************************************
*******************************************************************************)
begin
{
Directly dropping on an existing location, destroys all previous contents ??
  case drop_location of
    1: rvt.Receiver:=RVE_drop;
    2: rvt.Receiver:=drop_target2;
    3: rvt.Receiver:=drop_target3;
  end;
}
  rvt.Receiver:=RVE_drop;
end;


procedure TForm_transparent_drop.OleAfterDrop(
  Sender: TCustomRichView; X, Y: Integer;
  Format: TRVDragDropFormat; const Title: String);
(*******************************************************************************
// Note 1: this event is called only as a result of successful drop
// Note 2: when dropping multiple files, OleBeforeDrop & OleAfterDrop is
//         called for each file
*******************************************************************************)
begin
  rvt.Receiver := nil;
//  if drop_location=1 then
    application.MainForm.Perform(WM_MDI_menu_message,
                                 drop_location,//WMM_MDI_return_from_minimized_drop+(book_old shl 16),
                                 handle);
end;


procedure TForm_transparent_drop.OleEnter(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
begin
//
end;


procedure TForm_transparent_drop.OleLeave(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
begin
  set_transparency(transparency_org);
  set_book(0);
end;


procedure TForm_transparent_drop.FormActivate(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
var
  ii           :integer;
  ini_header   :string;
  inifile      :tmeminifile;
begin
  if firsttime then
  begin
    firsttime:=false;
    inifile:=tmeminifile.create(inifile_name);
    with inifile do
    try
      ini_header:='Drop_Icon';
      if sectionexists(ini_header) then
      begin
        left:=readinteger(ini_header,'left',left);
        top:=readinteger(ini_header,'top',top);
        transparency_org:=readinteger(ini_header,'transp',transparency_max);
      end;
    finally
      free;
    end;
  end;
  set_transparency(transparency_org);
  book_old:=-1;
  set_book(0);
end;


procedure TForm_transparent_drop.FormDestroy(Sender: TObject);
(*******************************************************************************
*******************************************************************************)
var
  ini_header :string;
  inifile    :tmeminifile;
begin
  inifile:=tmeminifile.create(inifile_name);
  with inifile do
  try
    ini_header:='Drop_Icon';
    erasesection(ini_header);
    writeinteger(ini_header,'left',left);
    writeinteger(ini_header,'top',top);
    writeinteger(ini_header,'transp',transparency_org);
  finally
    updatefile;
    free;
  end;
end;


procedure TForm_transparent_drop.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
(*******************************************************************************
To make the window floating, click somewhere and drag it anywhere.
All components on this form must be have there onmousedown attached to this procedure
*******************************************************************************)
begin
  //save x,y for popups
  mouse_down_x:=x;
  mouse_down_y:=y;
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, $F012, 0);
end;


procedure TForm_transparent_drop.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
(*******************************************************************************
*******************************************************************************)
begin
  set_transparency(transparency_org);
  set_book(0);
end;


procedure TForm_transparent_drop.RVE_dropRVMouseDown(
  Sender: TCustomRichView; Button: TMouseButton; Shift: TShiftState;
  ItemNo, X, Y: Integer);
(*******************************************************************************
*******************************************************************************)
begin
  //we need attach allmousedown actions to formmousedown
  //because the parameter definition of RVE is different,
  // we call it here with the correct parameters
  FormMouseDown(Sender,Button,Shift,X,Y);
end;


procedure TForm_transparent_drop.RVE_dropMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
(*******************************************************************************
Highlight left / middle or right part of the book, during mouseover
*******************************************************************************)
begin
  select_book_position(x);
end;


procedure TForm_transparent_drop.PopupMenu1Popup(Sender: TObject);
(*******************************************************************************
Block transparency item, if not available
*******************************************************************************)
begin
//  Transparency1.enabled:=winversion in [vWin2000,vWinXP];
end;


procedure TForm_transparent_drop.Transparency1Click(Sender: TObject);
(*******************************************************************************
Let the user correct the transparency
*******************************************************************************)
begin
  show_transparency_setting(handle,transparency_org,left+mouse_down_x,top+mouse_down_y);
end;


procedure TForm_transparent_drop.PuntHoofd1Click(Sender: TObject);
(*******************************************************************************
Back to users-mainform of PuntHoofd,
the userform, must supply the value of mainform
*******************************************************************************)
var
  hwndOwner: HWnd;
begin
  if application.mainform<>nil then
  begin
    hide;

    //restore the mainforms taskbar notation
    hwndOwner := GetWindow(application.mainform.Handle, GW_OWNER);
    ShowWindow(hwndOwner, SW_SHOWNORMAL);

    application.mainform.WindowState:=wsNormal;
    application.mainform.show;
    application.mainform.BringToFront;
    application.mainform.SetFocus;
  end;
end;


procedure TForm_transparent_drop.help1Click(Sender: TObject);
(*******************************************************************************
Show help about the transparent dropping form
*******************************************************************************)
begin
  //
end;


//TEMPORARY !!!!
procedure TForm_transparent_drop.RVE_dropDropFiles(
  Sender: TCustomRichViewEdit; Files: TStrings;
  var FileAction: TRVDropFileAction; var DoDefault: Boolean);
(*******************************************************************************
*******************************************************************************)
var
  i :integer;
begin
//  beep;
  for i:=0 to files.Count-1 do
    rve_drop.AddNL(files[i],0,0);
  application.MainForm.Perform(WM_MDI_menu_message,
                               drop_location,//WMM_MDI_return_from_minimized_drop+(book_old shl 16),
                               handle);
end;


initialization
  inifile_name:=changefileext(application.exename,'.ini');
end.

